/* Regulatory Signal Search (RSS) */
/* Functions: FreeSborka, FreeHistory, MyRandom, MySrand */
/* L.Rubanov, 2006 */
#include <stdio.h>
#include <stdlib.h>
#include "rss01.h"

void FreeSborka(SBORKA *sborka) {
int i, *pp;
short *p, **q;
   if(sborka==NULL)  return;
   if((p=sborka->p)!=NULL)  free(p);
   if((q=sborka->tree)!=NULL) {
      for(i=0; i<LOGNMAX; i++)
         if(q[i]!=NULL)    free(q[i]);
      free(q);
   }
   if((p=sborka->suu)!=NULL)  free(p);
   if((p=sborka->suv)!=NULL)  free(p);
   if((p=sborka->l1)!=NULL)  free(p);
   if((p=sborka->l2)!=NULL)  free(p);
   if((pp=sborka->cuu)!=NULL)  free(pp);
   if((pp=sborka->cuv)!=NULL)  free(pp);
}

void FreeHistory(void) {
int   i, *pp;
short *p;
   while(hist1) {                /* Free history list */
      if((p=hist1->p)!=NULL)   free(p);
      if((pp=hist1->s)!=NULL)    free(pp);
      if((pp=hist1->qw)!=NULL)   free(pp);
      if((pp=hist1->qwavg)!=NULL) free(pp);
      hist2 = hist1->next;
      free(hist1);
      hist1 = hist2;
   }
   hist2=NULL;
   if(lambda) {
      for(i=0; i<n; i++)
         if((pp=lambda[i])!=NULL)   free(pp);
      free(lambda);  lambda=NULL;
   }
   if(cover)   { free(cover);  cover=NULL; }
}

#ifdef MYRANDOM
static long idum=0x55555555;
#define	IA		16807
#define	IM		2147483647
#define	AM		(1.0/IM)
#define	IQ		127773
#define	IR		2836
#define	MASK	123459876
/* "Minimal" random number generator of Park and Miller. Returns a uniform
   random deviate between 0.0 and 1.0 (exclusive). Set or reset idum to any
   integer value (except the unlikely value MASK) to initialize the sequence;
   idum must not be altered between calls for sussessive deviates in a sequence.
   The period of ran0 is 2^31-2 (~=2.1E9) */
float ran0( long *idum ) {
	long	k;
   float	ans;
   *idum ^= MASK;						/* XORing with MASK allows use of 0 and other */
   k=(*idum)/IQ;                 /*  simple bit patterns for idum */
   *idum=IA*(*idum-k*IQ)-IR*k;	/* Compute idum=(IA*idum)%IM without overflows */
   if( *idum<0 ) *idum += IM;		/*  by Schrage's method */
   ans=AM*(*idum);					/* Conver idum to floating result */
   *idum ^= MASK;						/* Unmask before return */
   return ans;
}
#define MYRAND_MAX	32767
int MyRandom(void) {
   return (int)(ran0(&idum)*(MYRAND_MAX+1.0));
}
void MySrand(unsigned seed) {
	idum = (long)seed;
}
#endif

